
#include "generic.h"	//EDITME

#include "resource.h"

#include "genericwnd.h"

#include "../studio/services/servicei.h"     // For the service template.
#include "../studio/services/svc_wndcreate.h"

#include "../common/SimpleWndCreate.h"

static WACNAME wac;
WACPARENT *the = &wac;
WACNAME * WACNAME::myInstance = NULL;
static const GUID guid = 
{ 0, 0, 0, { 0, 0, 0, 0, 0, 0, 0, 0 } };	//EDITME (hint: use guidgen.exe)

// *** WindowCreationServiceObject for this example.
static waServiceT<svc_windowCreate, ThingerWndCreateSvc< WACNAME > >  Generic_WndCreateSvc;

WACNAME::WACNAME() {
  // Only allow a single instance to be constructed.
  ASSERT( myInstance == NULL );
  myInstance = this;
#ifdef FORTIFY
  FortifySetName("Generic.wac");
  FortifyEnterScope();
#endif
  wnd = NULL;
}

WACNAME::~WACNAME() {
#ifdef FORTIFY
  FortifyLeaveScope();
#endif
}

const char *WACNAME::getName() {
  return "Generic Component Template"; //EDITME
}

GUID WACNAME::getGUID() {
  return guid;
}

ThingerBitmapInfo WACNAME::getThingerBitmapInfo() {
  return ThingerBitmapInfo(gethInstance(), IDB_TAB_NORMAL, NULL, IDB_TAB_HILITED, IDB_TAB_SELECTED);
}

void WACNAME::onCreate() {
  // *** Do startup stuff here that doesn't require you to have a window yet
}

void WACNAME::onRegisterServices() {
  // ***  Register our window creation service here.
  //      If we don't do this, we don't get a window.
  api->service_register(&Generic_WndCreateSvc); 
  api->register_autoPopupGUID(getGUID(), getName());
}

void WACNAME::onDestroy() {
  // ***  Deregister our window creation service here.
  //      If we don't do this, we get a memory leak.
  api->service_deregister(&Generic_WndCreateSvc);
  // be sure to delete all your windows etc HERE, not in the destructor
  // because the API pointer might be invalid in the destructor
  delete wnd; wnd = NULL;
  WACPARENT::onDestroy();
}

int WACNAME::destroyWindow(RootWnd * deadWnd) {
  if ((deadWnd != NULL)&&(deadWnd == wnd)) {
    delete deadWnd;
    wnd = NULL;
    return 1;
  }
  return 0;
}

RootWnd *WACNAME::createWindow(int n, RootWnd *parentWnd) {
  if (n == 0) {
    if (wnd != NULL) return NULL;
    wnd = new GenericWnd;
    wnd->init(parentWnd);
    return wnd;
  }
  return 0;
}

